diff --git a/src/main/java/net/minecraft/core/block/BlockOreNetherCoal.java b/src/main/java/net/minecraft/core/block/DiamondOreBlock.java
similarity index 54%
rename from src/main/java/net/minecraft/core/block/BlockOreNetherCoal.java
rename to src/main/java/net/minecraft/core/block/DiamondOreBlock.java
index 16c3f5179..a36e0c4f4 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreNetherCoal.java
+++ b/src/main/java/net/minecraft/core/block/DiamondOreBlock.java
@@ -1,26 +1,29 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 
+import java.util.HashMap;
+import java.util.Map;
+
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, Item
 
-public class BlockOreNetherCoal extends Block
+public class DiamondOreBlock extends Block
 {
-
-    public BlockOreNetherCoal(String key, int id)
+    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    public DiamondOreBlock(String key, String namespaceId, int id, int parentId, Material material)
     {
-        super(key, id, Material.stone);
+        super(key, namespaceId, id, material);
+        variantMap.put(parentId, id);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -29,9 +32,10 @@ public class BlockOreNetherCoal extends Block
                 return new ItemStack[] { new ItemStack(this) };
             case EXPLOSION:
             case PROPER_TOOL:
-                return new ItemStack[] { new ItemStack(Item.nethercoal) };
+                return new ItemStack[] { new ItemStack(Items.DIAMOND) };
             default:
                 return null;
         }
     }
+
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockDirtPath.java b/src/main/java/net/minecraft/core/block/DirtPathBlock.java
similarity index 67%
rename from src/main/java/net/minecraft/core/block/BlockDirtPath.java
rename to src/main/java/net/minecraft/core/block/DirtPathBlock.java
index 0ac7d9545..735ee53f4 100644
--- a/src/main/java/net/minecraft/core/block/BlockDirtPath.java
+++ b/src/main/java/net/minecraft/core/block/DirtPathBlock.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -12,11 +12,11 @@ import net.minecraft.core.world.WorldSource;
 //            Block, Material, AxisAlignedBB, World,
 //            Entity
 
-public class BlockDirtPath extends Block
+public class DirtPathBlock extends Block
 {
-	public BlockDirtPath(String key, int id)
+	public DirtPathBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.dirt);
+        super(key, namespaceId, id, Material.dirt);
         setTicking(true);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.9375F, 1.0F);
         withLightBlock(255);
@@ -25,7 +25,7 @@ public class BlockDirtPath extends Block
     @Override
 	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
     {
-        return AABB.getBoundingBoxFromPool(x + 0, y + 0, z + 0, x + 1, y + 1, z + 1);
+        return AABB.getTemporaryBB(x + 0, y + 0, z + 0, x + 1, y + 1, z + 1);
     }
 
     @Override
@@ -35,7 +35,7 @@ public class BlockDirtPath extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -46,14 +46,14 @@ public class BlockDirtPath extends Block
         super.onNeighborBlockChange(world, x, y, z, blockId);
         Material material = world.getBlockMaterial(x, y + 1, z);
         int id = world.getBlockId(x, y + 1, z);
-        if(material.isSolid() && id != Block.fencegatePlanksOak.id && id != Block.fencegatePlanksOakPainted.id && id != Block.signWallPlanksOak.id)
+        if(material.isSolid() && id != Blocks.FENCE_GATE_PLANKS_OAK.id && id != Blocks.FENCE_GATE_PLANKS_OAK_PAINTED.id && id != Blocks.SIGN_WALL_PLANKS_OAK.id)
         {
-            world.setBlockWithNotify(x, y, z, Block.dirt.id);
+            world.setBlockWithNotify(x, y, z, Blocks.DIRT.id);
         }
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -61,7 +61,7 @@ public class BlockDirtPath extends Block
             case PICK_BLOCK:
                 return new ItemStack[] { new ItemStack(this) };
             default:
-                return new ItemStack[] { new ItemStack(Block.dirt) };
+                return new ItemStack[] { new ItemStack(Blocks.DIRT) };
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockDispenser.java b/src/main/java/net/minecraft/core/block/DispenserBlock.java
similarity index 60%
rename from src/main/java/net/minecraft/core/block/BlockDispenser.java
rename to src/main/java/net/minecraft/core/block/DispenserBlock.java
index b41656665..7a0d721cd 100644
--- a/src/main/java/net/minecraft/core/block/BlockDispenser.java
+++ b/src/main/java/net/minecraft/core/block/DispenserBlock.java
@@ -2,57 +2,60 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.DispenserBlockEntity;
 import net.minecraft.core.entity.*;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.*;
 import net.minecraft.core.item.IDispensable;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.block.material.Material;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockContainer, Material, Block, World, 
-//            IBlockAccess, TileEntityDispenser, EntityPlayer, ItemStack, 
-//            Item, EntityArrow, EntityEgg, EntitySnowball, 
-//            EntityItem, EntityLiving, MathHelper, IInventory, 
-//            TileEntity
+//            IBlockAccess, DispenserBlockEntity, Player, ItemStack,
+//            Item, ArrowProjectile, EggProjectile, SnowballProjectile,
+//            ItemEntity, Mob, MathHelper, IInventory,
+//            BlockEntity
 
-public class BlockDispenser extends BlockTileEntityRotatable
+public class DispenserBlock extends RotatableEntityBlock
 {
+    private Random random;
+
 
-	public BlockDispenser(String key, int id)
+	public DispenserBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.stone);
+        super(key, namespaceId, id, Material.stone);
         random = new Random();
     }
 
     @Override
-    public int tickRate()
+    public int tickDelay()
     {
         return 4;
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
-        setDispenserDefaultDirection(world, x, y, z);
+        super.onBlockPlacedByWorld(world, x, y, z);
+        recalculateLookDirection(world, x, y, z);
     }
 
-    private void setDispenserDefaultDirection(World world, int i, int j, int k)
+    private void recalculateLookDirection(World world, int x, int y, int z)
     {
         if(world.isClientSide)
         {
             return;
         }
-        int l = world.getBlockId(i, j, k - 1);
-        int i1 = world.getBlockId(i, j, k + 1);
-        int j1 = world.getBlockId(i - 1, j, k);
-        int k1 = world.getBlockId(i + 1, j, k);
+        int l = world.getBlockId(x, y, z - 1);
+        int i1 = world.getBlockId(x, y, z + 1);
+        int j1 = world.getBlockId(x - 1, y, z);
+        int k1 = world.getBlockId(x + 1, y, z);
         byte byte0 = 3;
         if(Block.solid[l] && !Block.solid[i1])
         {
@@ -70,19 +73,19 @@ public class BlockDispenser extends BlockTileEntityRotatable
         {
             byte0 = 4;
         }
-        world.setBlockMetadataWithNotify(i, j, k, byte0);
+        world.setBlockMetadataWithNotify(x, y, z, byte0);
     }
 
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if(world.isClientSide)
         {
             return true;
         } else
         {
-            TileEntityDispenser tileentitydispenser = (TileEntityDispenser)world.getBlockTileEntity(x, y, z);
+            DispenserBlockEntity tileentitydispenser = (DispenserBlockEntity)world.getBlockEntity(x, y, z);
             player.displayGUIDispenser(tileentitydispenser);
             return true;
         }
@@ -102,14 +105,14 @@ public class BlockDispenser extends BlockTileEntityRotatable
         } else {
             xOffset = -1;
         }
-        TileEntityDispenser tileEntity = (TileEntityDispenser)world.getBlockTileEntity(x, y, z);
+        DispenserBlockEntity tileEntity = (DispenserBlockEntity)world.getBlockEntity(x, y, z);
         ItemStack itemStack = tileEntity.getRandomStackFromInventory();
         double px = (double)x + (double)xOffset * 0.6D + 0.5D;
         double py = (double)y + 0.5D;
         double pz = (double)z + (double)zOffset * 0.6D + 0.5D;
         if(itemStack == null)
         {
-            world.playSoundEffect(1001, x, y, z, 0);
+            world.playSoundEffect(LevelListener.EVENT_DISPENSER_EMPTY, x, y, z, 0);
         }
         else
         {
@@ -117,26 +120,27 @@ public class BlockDispenser extends BlockTileEntityRotatable
             {
                 IDispensable dispensable = (IDispensable) itemStack.getItem();
                 dispensable.onDispensed(itemStack, world, px, py, pz, xOffset, zOffset, random);
-                world.playSoundEffect(1002, x, y, z, 0);
+                world.playSoundEffect(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
             }
-            else if (itemStack.itemID == Item.ammoArrow.id || itemStack.itemID == Item.ammoArrowGold.id)
+            else if (itemStack.itemID == Items.AMMO_ARROW.id || itemStack.itemID == Items.AMMO_ARROW_GOLD.id)
             {
-                EntityArrow arrow = itemStack.itemID == Item.ammoArrow.id ? new EntityArrow(world, px, py, pz, 0) : new EntityArrowGolden(world, px, py, pz);
+
+                ArrowProjectile arrow = itemStack.itemID == Items.AMMO_ARROW.id ? new ArrowProjectile(world, px, py, pz, 0) : new ArrowProjectileGolden(world, px, py, pz);
                 arrow.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
                 arrow.setDoesArrowBelongToPlayer(true);
                 world.entityJoinedWorld(arrow);
-                world.playSoundEffect(1002, x, y, z, 0);
+                world.playSoundEffect(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
             }
-            else if (itemStack.itemID == Item.ammoChargeExplosive.id)
+            else if (itemStack.itemID == Items.AMMO_CHARGE_EXPLOSIVE.id)
             {
-                EntityCannonball cannonball = new EntityCannonball(world, px, py, pz);
-                cannonball.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
-                world.entityJoinedWorld(cannonball);
-                world.playSoundEffect(1002, x, y, z, 0);
+                CannonballProjectile cannonballProjectile = new CannonballProjectile(world, px, py, pz);
+                cannonballProjectile.setHeading(xOffset, 0.1D, zOffset, 1.1F, 6F);
+                world.entityJoinedWorld(cannonballProjectile);
+                world.playSoundEffect(LevelListener.EVENT_DISPENSER_PROJECTILE, x, y, z, 0);
             }
             else
             {
-                EntityItem item = new EntityItem(world, px, py - 0.3D, pz, itemStack);
+                ItemEntity item = new ItemEntity(world, px, py - 0.3D, pz, itemStack);
                 double randOffset = random.nextDouble() * 0.1D + 0.2D;
                 item.xd = (double)xOffset * randOffset;
                 item.yd = 0.2D;
@@ -145,21 +149,21 @@ public class BlockDispenser extends BlockTileEntityRotatable
                 item.yd += random.nextGaussian() * 0.0075D * 6D;
                 item.zd += random.nextGaussian() * 0.0075D * 6D;
                 world.entityJoinedWorld(item);
-                world.playSoundEffect(1000, x, y, z, 0);
+                world.playSoundEffect(LevelListener.EVENT_DISPENSER_ITEM, x, y, z, 0);
             }
-            world.playSoundEffect(2000, x, y, z, xOffset + 1 + (zOffset + 1) * 3);
+            world.playSoundEffect(LevelListener.EVENT_DISPENSER_PARTICLES, x, y, z, xOffset + 1 + (zOffset + 1) * 3);
         }
     }
 
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        if(blockId > 0 && Block.blocksList[blockId].canProvidePower())
+        if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
         {
             boolean flag = world.isBlockIndirectlyGettingPowered(x, y, z) || world.isBlockIndirectlyGettingPowered(x, y + 1, z);
             if(flag)
             {
-                world.scheduleBlockUpdate(x, y, z, id, tickRate());
+                world.scheduleBlockUpdate(x, y, z, id, tickDelay());
             }
         }
     }
@@ -174,19 +178,19 @@ public class BlockDispenser extends BlockTileEntityRotatable
     }
 
     @Override
-	protected TileEntity getNewBlockEntity()
+	protected BlockEntity getNewBlockEntity()
     {
-        return new TileEntityDispenser();
+        return new DispenserBlockEntity();
     }
-    
+
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        if(world.getBlockTileEntity(x, y, z) != null) {
-            TileEntityDispenser tileentitydispenser = (TileEntityDispenser) world.getBlockTileEntity(x, y, z);
+        if(world.getBlockEntity(x, y, z) != null) {
+            DispenserBlockEntity tileentitydispenser = (DispenserBlockEntity) world.getBlockEntity(x, y, z);
             label0:
-            for (int l = 0; l < tileentitydispenser.getSizeInventory(); l++) {
-                ItemStack itemstack = tileentitydispenser.getStackInSlot(l);
+            for (int l = 0; l < tileentitydispenser.getContainerSize(); l++) {
+                ItemStack itemstack = tileentitydispenser.getItem(l);
                 if (itemstack == null) {
                     continue;
                 }
@@ -202,7 +206,7 @@ public class BlockDispenser extends BlockTileEntityRotatable
                         i1 = itemstack.stackSize;
                     }
                     itemstack.stackSize -= i1;
-                    EntityItem entityitem = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+                    ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
                     float f3 = 0.05F;
                     entityitem.xd = (float) random.nextGaussian() * f3;
                     entityitem.yd = (float) random.nextGaussian() * f3 + 0.2F;
@@ -214,6 +218,4 @@ public class BlockDispenser extends BlockTileEntityRotatable
 
         super.onBlockRemoved(world, x, y, z, data);
     }
-
-    private Random random;
 }
diff --git a/src/main/java/net/minecraft/core/block/BlockDoor.java b/src/main/java/net/minecraft/core/block/DoorBlock.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/BlockDoor.java
rename to src/main/java/net/minecraft/core/block/DoorBlock.java
index cbfa6e537..46f984580 100644
--- a/src/main/java/net/minecraft/core/block/BlockDoor.java
+++ b/src/main/java/net/minecraft/core/block/DoorBlock.java
@@ -2,33 +2,34 @@ package net.minecraft.core.block;
 
 import java.util.Random;
 
-import net.minecraft.core.HitResult;
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, IBlockAccess, World, 
-//            Item, AxisAlignedBB, EntityPlayer, Vec3D, 
+//            Item, AxisAlignedBB, Player, Vec3D,
 //            MovingObjectPosition
 
-public class BlockDoor extends Block
+public class DoorBlock extends Block
 {
 
 	public final boolean isTop; 
 	
-	public BlockDoor(String key, int id, Material material, boolean isTop)
+	public DoorBlock(String key, String namespaceId, int id, Material material, boolean isTop)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         this.isTop = isTop;
         float f = 0.5F;
         if (isTop)
@@ -48,7 +49,7 @@ public class BlockDoor extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -107,14 +108,14 @@ public class BlockDoor extends Block
     }
     
     @Override
-	public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit) {
+	public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
     	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
     		onBlockRightClicked(world, x, y, z, player, side, xHit, yHit);
     	}
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if(blockMaterial == Material.metal)
         {
@@ -123,13 +124,13 @@ public class BlockDoor extends Block
         int l = world.getBlockMetadata(x, y, z);
         if(isTop)
         {
-            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
+            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof DoorBlock)
             {
             	Block.blocksList[world.getBlockId(x, y - 1, z)].onBlockRightClicked(world, x, y - 1, z, player, side, xPlaced, yPlaced);
             }
             return true;
         }
-        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
+        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof DoorBlock)
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, l ^ 4);
         }
@@ -147,9 +148,9 @@ public class BlockDoor extends Block
         
         if(isTop)
         {
-            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof BlockDoor)
+            if(Block.blocksList[world.getBlockId(x, y - 1, z)] instanceof DoorBlock)
             {
-            	((BlockDoor)Block.blocksList[world.getBlockId(x, y - 1, z)]).onPoweredBlockChange(world, x, y - 1, z, isPowered);
+            	((DoorBlock)Block.blocksList[world.getBlockId(x, y - 1, z)]).onPoweredBlockChange(world, x, y - 1, z, isPowered);
             }
             return;
         }
@@ -158,7 +159,7 @@ public class BlockDoor extends Block
         {
             return;
         }
-        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof BlockDoor)
+        if(Block.blocksList[world.getBlockId(x, y + 1, z)] instanceof DoorBlock)
         {
             world.setBlockMetadataWithNotify(x, y + 1, z, l ^ 4);
         }
@@ -174,11 +175,11 @@ public class BlockDoor extends Block
         if(isTop)
         {
         	Block otherBlock = Block.blocksList[world.getBlockId(x, y - 1, z)];
-            if(!(otherBlock instanceof BlockDoor))
+            if(!(otherBlock instanceof DoorBlock))
             {
                 world.setBlockWithNotify(x, y, z, 0);
             }
-            if(blockId > 0 && Block.blocksList[blockId].canProvidePower())
+            if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
             {
                 otherBlock.onNeighborBlockChange(world, x, y - 1, z, blockId);
             }
@@ -186,7 +187,7 @@ public class BlockDoor extends Block
         {
             boolean flag = false;
         	Block otherBlock = Block.blocksList[world.getBlockId(x, y + 1, z)];
-            if(!(otherBlock instanceof BlockDoor))
+            if(!(otherBlock instanceof DoorBlock))
             {
                 world.setBlockWithNotify(x, y, z, 0);
                 //dropBlockAsItem(world, i, j, k, i1);
@@ -197,7 +198,7 @@ public class BlockDoor extends Block
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
                 world.setBlockWithNotify(x, y, z, 0);
                 flag = true;
-                if(otherBlock instanceof BlockDoor)
+                if(otherBlock instanceof DoorBlock)
                 {
                     world.setBlockWithNotify(x, y + 1, z, 0);
                 }
@@ -209,7 +210,7 @@ public class BlockDoor extends Block
                     //dropBlockAsItem(world, i, j, k, i1);
                 }
             } else
-            if(blockId > 0 && Block.blocksList[blockId].canProvidePower())
+            if(blockId > 0 && Block.blocksList[blockId].isSignalSource())
             {
                 boolean flag1 = world.isBlockIndirectlyGettingPowered(x, y, z) || world.isBlockIndirectlyGettingPowered(x, y + 1, z);
                 onPoweredBlockChange(world, x, y, z, flag1);
@@ -218,39 +219,39 @@ public class BlockDoor extends Block
     }
     
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
     	int myId = world.getBlockId(x, y, z);
     	int myMetadata = world.getBlockMetadata(x, y, z);
     	int upId = world.getBlockId(x, y + 1, z);
     	
-    	if (myId == Block.doorPlanksOakBottom.id && upId == Block.doorPlanksOakBottom.id)
+    	if (myId == Blocks.DOOR_PLANKS_OAK_BOTTOM.id && upId == Blocks.DOOR_PLANKS_OAK_BOTTOM.id)
     	{
-    		world.setBlockAndMetadata(x, y + 1, z, Block.doorPlanksOakTop.id, myMetadata);
+    		world.setBlockAndMetadata(x, y + 1, z, Blocks.DOOR_PLANKS_OAK_TOP.id, myMetadata);
     	}
-    	else if (myId == Block.doorIronBottom.id && upId == Block.doorIronBottom.id)
+    	else if (myId == Blocks.DOOR_IRON_BOTTOM.id && upId == Blocks.DOOR_IRON_BOTTOM.id)
     	{
-    		world.setBlockAndMetadata(x, y + 1, z, Block.doorIronTop.id, myMetadata);
+    		world.setBlockAndMetadata(x, y + 1, z, Blocks.DOOR_IRON_TOP.id, myMetadata);
     	}
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         if (blockMaterial == Material.metal && dropCause != EnumDropCause.IMPROPER_TOOL)
         {
-            return new ItemStack[] { new ItemStack(Item.doorIron) };
+            return new ItemStack[] { new ItemStack(Items.DOOR_IRON) };
         }
         else if (blockMaterial == Material.wood)
         {
-            return new ItemStack[] { new ItemStack(Item.doorOak) };
+            return new ItemStack[] { new ItemStack(Items.DOOR_OAK) };
         }
 
         return null;
     }
 
     @Override
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3d start, Vec3d end)
+    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end)
     {
         setBlockBoundsBasedOnState(world, x, y, z);
         return super.collisionRayTrace(world, x, y, z, start, end);
diff --git a/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java b/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
new file mode 100644
index 000000000..5f4710ab4
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/DoorPaintedBlock.java
@@ -0,0 +1,19 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.World;
+
+public class DoorPaintedBlock extends DoorBlock {
+    public DoorPaintedBlock(String key, String namespaceId, int id, Material material, boolean isTop) {
+        super(key, namespaceId, id, material, isTop);
+    }
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
+    {
+        return new ItemStack[] { new ItemStack(Items.DOOR_OAK_PAINTED, 1, 15 - (meta >> 4 & 0xF)) };
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockEdible.java b/src/main/java/net/minecraft/core/block/EdibleBlock.java
similarity index 80%
rename from src/main/java/net/minecraft/core/block/BlockEdible.java
rename to src/main/java/net/minecraft/core/block/EdibleBlock.java
index 76e6a1230..15b1d0610 100644
--- a/src/main/java/net/minecraft/core/block/BlockEdible.java
+++ b/src/main/java/net/minecraft/core/block/EdibleBlock.java
@@ -1,8 +1,8 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
@@ -12,16 +12,16 @@ import org.jetbrains.annotations.NotNull;
 
 import java.util.function.Supplier;
 
-public abstract class BlockEdible extends Block {
+public abstract class EdibleBlock extends Block {
     public Item item;
     @NotNull
     private final Supplier<Item> itemSupplier;
     public int maxBites;
     public int healAmount;
 
-    public BlockEdible(String key, int id, int maxBites, int healAmount, @NotNull Supplier<Item> dropItemSupplier)
+    public EdibleBlock(String key, String namespaceId, int id, int maxBites, int healAmount, @NotNull Supplier<Item> dropItemSupplier)
     {
-        super(key, id, Material.cake);
+        super(key, namespaceId, id, Material.cake);
         this.maxBites = maxBites;
         this.healAmount = healAmount;
         this.itemSupplier = dropItemSupplier;
@@ -33,7 +33,7 @@ public abstract class BlockEdible extends Block {
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         if (dropCause == EnumDropCause.PICK_BLOCK || meta == 0)
         {
@@ -44,7 +44,7 @@ public abstract class BlockEdible extends Block {
     }
 
     @Override
-    public boolean renderAsNormalBlock()
+    public boolean isCubeShaped()
     {
         return false;
     }
@@ -55,7 +55,7 @@ public abstract class BlockEdible extends Block {
         return false;
     }
 
-    private void eatSlice(World world, int x, int y, int z, EntityPlayer entityplayer)
+    private void eatSlice(World world, int x, int y, int z, Player entityplayer)
     {
         if(entityplayer.getHealth() < entityplayer.getMaxHealth())
         {
@@ -73,7 +73,7 @@ public abstract class BlockEdible extends Block {
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         eatSlice(world, x, y, z, player);
         return true;
diff --git a/src/main/java/net/minecraft/core/block/BlockTileEntity.java b/src/main/java/net/minecraft/core/block/EntityBlock.java
similarity index 53%
rename from src/main/java/net/minecraft/core/block/BlockTileEntity.java
rename to src/main/java/net/minecraft/core/block/EntityBlock.java
index 99dffbe15..7625c31d5 100644
--- a/src/main/java/net/minecraft/core/block/BlockTileEntity.java
+++ b/src/main/java/net/minecraft/core/block/EntityBlock.java
@@ -2,25 +2,25 @@ package net.minecraft.core.block;
 
 
 // Referenced classes of package net.minecraft.src:
-//            Block, World, Material, TileEntity
+//            Block, World, Material, BlockEntity
 
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
 
-public abstract class BlockTileEntity extends Block
+public abstract class EntityBlock extends Block
 {
 
-	public BlockTileEntity(String key, int id, Material material)
+	public EntityBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         isEntityTile[id] = true;
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
+        super.onBlockPlacedByWorld(world, x, y, z);
         world.setBlockTileEntity(x, y, z, getNewBlockEntity());
     }
 
@@ -31,5 +31,5 @@ public abstract class BlockTileEntity extends Block
         world.removeBlockTileEntity(x, y, z);
     }
 
-    protected abstract TileEntity getNewBlockEntity();
+    protected abstract BlockEntity getNewBlockEntity();
 }
